//+------------------------------------------------------------------+
//|                                                      Channel.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  GPL General Public License"
#property link      "open source fx community"

#property indicator_chart_window#include ""
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Yellow


extern int       ChannelPeriod = 20; 


//---- buffers
double UpLine[];
double DownLine[];
double MiddleLine[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,UpLine);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,DownLine);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,MiddleLine);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
      string short_name = "G("+ChannelPeriod+")";
      IndicatorShortName(short_name);
   
  ObjectCreate("G", OBJ_LABEL, 0, 0,0);
  ObjectSet("G", OBJPROP_XDISTANCE,0);
  ObjectSet("G", OBJPROP_YDISTANCE, 10);  
  ObjectSetText("G", "G", 1, "Verdana", White );      
  
   int    counted_bars=IndicatorCounted();

   
 //  int countBars = 500;
   int i = 0;     
      
   int barsToCount = Bars - counted_bars;
      
   while(i <= barsToCount)
   {
      
      UpLine[i] = High[ Highest(NULL, 0, MODE_HIGH, ChannelPeriod, i+1) ];            
      DownLine[i] = Low[ Lowest(NULL, 0, MODE_LOW, ChannelPeriod, i+1) ];
      //MiddleLine[i] = (UpLine[i] + DownLine[i])/2;
      

   i++;
  }
//----
   return(0);
  }
//+------------------------------------------------------------------+